



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MySQL添加可重复执行列</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MySQL添加可重复执行列</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 14:40:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>一、information_schema数据库表说明:</h2>
<p>SCHEMATA表：提供了当前mysql实例中所有数据库的信息。是show databases的结果取之此表。</p>
<p>TABLES表：提供了关于数据库中的表的信息（包括视图）。详细表述了某个表属于哪个schema，表类型，表引擎，创建时间等信息。是show tables from schemaname的结果取之此表。</p>
<p>COLUMNS表：提供了表中的列信息。详细表述了某张表的所有列以及每个列的信息。是show columns from schemaname.tablename的结果取之此表。</p>
<p>STATISTICS表：提供了关于表索引的信息。是show index from schemaname.tablename的结果取之此表。</p>
<p>USER_PRIVILEGES（用户权限）表：给出了关于全程权限的信息。该信息源自mysql.user授权表。是非标准表。</p>
<p>SCHEMA_PRIVILEGES（方案权限）表：给出了关于方案（数据库）权限的信息。该信息来自mysql.db授权表。是非标准表。</p>
<p>TABLE_PRIVILEGES（表权限）表：给出了关于表权限的信息。该信息源自mysql.tables_priv授权表。是非标准表。</p>
<p>COLUMN_PRIVILEGES（列权限）表：给出了关于列权限的信息。该信息源自mysql.columns_priv授权表。是非标准表。</p>
<p>CHARACTER_SETS（字符集）表：提供了mysql实例可用字符集的信息。是SHOW CHARACTER SET结果集取之此表。</p>
<p>COLLATIONS表：提供了关于各字符集的对照信息。</p>
<p>COLLATION_CHARACTER_SET_APPLICABILITY表：指明了可用于校对的字符集。这些列等效于SHOW COLLATION的前两个显示字段。</p>
<p>TABLE_CONSTRAINTS表：描述了存在约束的表。以及表的约束类型。</p>
<p>KEY_COLUMN_USAGE表：描述了具有约束的键列。</p>
<p>ROUTINES表：提供了关于存储子程序（存储程序和函数）的信息。此时，ROUTINES表不包含自定义函数（UDF）。名为&ldquo;mysql.proc name&rdquo;的列指明了对应于INFORMATION_SCHEMA.ROUTINES表的mysql.proc表列。</p>
<p>VIEWS表：给出了关于数据库中的视图的信息。需要有show views权限，否则无法查看视图信息。</p>
<p>TRIGGERS表：提供了关于触发程序的信息。必须有super权限才能查看该表</p>
<h2>二、存储过程实现</h2>
<p>思路：</p>
<p>1.先判断表是否存在；</p>
<p>2.判断列名是否存在该表中；</p>
<p>3.判断null、default是否存在属性中；</p>
<p>4.判断是否需要插入到某个列名之后；</p>
<p>5.拼装sql语句；</p>
<p>6.执行添加字段的sql语句；</p>
<div>
<pre class="prettyprint linenums"> drop procedure if exists `AddColumnIfNotExists`;<br />
 delimiter $$<br />
 create procedure AddColumnIfNotExists(in tableName varchar(50),in columnName varchar(50),in discription varchar(256), in position varchar(50))<br />
 begin<br />
     declare tableCount int default 0;  #用于判断表是否存在<br />
     declare columnCount int default 0; #用于判断字段是否存在<br />
     declare stmt varchar(2000); #最终拼接出来的sql语句<br />
     declare seat int default 0; #用于判断null/default的位置

     SELECT count(*) into @tableCount FROM information_schema.TABLES WHERE TABLE_SCHEMA = (SELECT DATABASE()) AND TABLE_NAME = tableName;<br />
     SELECT count(*) into @columnCount FROM information_schema.COLUMNS WHERE TABLE_SCHEMA = (SELECT DATABASE()) AND TABLE_NAME = tableName AND COLUMN_NAME = columnName;

     if @tableCount=1 &amp;&amp; @columnCount=0 then<br />
         set @seat = locate('null', discription);<br />
         if  @seat &gt; 0 then #判断是否存在null<br />
             set @stmt = CONCAT(' ALTER TABLE `',tableName,'` ADD COLUMN `',columnName,'` ',discription);<br />
         else<br />
             set @seat = locate('default', discription);<br />
             if @seat &gt; 0 then #判断是否存在default<br />
                 set @stmt = CONCAT(' ALTER TABLE `',tableName,'` ADD COLUMN `',columnName,'` ',discription, ' NOT NULL');<br />
             else<br />
                 set @stmt = CONCAT(' ALTER TABLE `',tableName,'` ADD COLUMN `',columnName,'` ',discription, ' NULL');<br />
             end if;<br />
         end if;

         if position != '' then #判断是否需要插入某个字段的后面<br />
             set @stmt = CONCAT(@stmt, ' after ', position, ';');<br />
         else<br />
             set @stmt = CONCAT(@stmt, ';');<br />
         end if;

         PREPARE stmt1 FROM @stmt;<br />
         EXECUTE stmt1;<br />
         DEALLOCATE PREPARE stmt1;<br />
         select @stmt;<br />
     end if;<br />
 end$$<br />
 delimiter ;</pre>
</div>
<h2>三、测试</h2>
<p><strong>调用方式：call AddColumnIfNotExists(表名, 字段名,属性, 插入到那个字段之后);</strong></p>
<h3>1.新建一个员工表</h3>
<div>
<pre class="prettyprint linenums">#员工表<br />
CREATE TABLE emp(<br />
    empno MEDIUMINT UNSIGNED  NOT NULL  DEFAULT 0 comment '编号',<br />
    ename VARCHAR(20) NOT NULL DEFAULT "" comment '名字',<br />
    job VARCHAR(9) NOT NULL DEFAULT "" comment '工作',<br />
    mgr MEDIUMINT UNSIGNED NOT NULL DEFAULT 0 comment '上级编号'<br />
)ENGINE=MyISAM DEFAULT CHARSET=utf8 ;</pre>
</div>
<div>
<pre class="prettyprint linenums">mysql&gt; desc emp;<br />
+-------+-----------------------+------+-----+---------+-------+<br />
| Field | Type                  | Null | Key | Default | Extra |<br />
+-------+-----------------------+------+-----+---------+-------+<br />
| empno | mediumint(8) unsigned | NO   |     | 0       |       |<br />
| ename | varchar(20)           | NO   |     |         |       |<br />
| job   | varchar(9)            | NO   |     |         |       |<br />
| mgr   | mediumint(8) unsigned | NO   |     | 0       |       |<br />
+-------+-----------------------+------+-----+---------+-------+<br />
4 rows in set (0.01 sec)</pre>
</div>
<h4>2.新插入字段</h4>
<p>(1)无null、无default</p>
<div>
<pre class="prettyprint linenums">mysql&gt; call AddColumnIfNotExists('emp', 'hiredatea', 'DATE comment "入职时间"','');<br />
+-------------------------------------------------------------------------+<br />
| @stmt                                                                   |<br />
+-------------------------------------------------------------------------+<br />
|  ALTER TABLE `emp` ADD COLUMN `hiredatea` DATE comment "入职时间" NULL;<br />
|<br />
+-------------------------------------------------------------------------+<br />
1 row in set (0.09 sec)

Query OK, 0 rows affected (0.13 sec)

mysql&gt; desc emp;<br />
+-----------+-----------------------+------+-----+---------+-------+<br />
| Field     | Type                  | Null | Key | Default | Extra |<br />
+-----------+-----------------------+------+-----+---------+-------+<br />
| empno     | mediumint(8) unsigned | NO   |     | 0       |       |<br />
| ename     | varchar(20)           | NO   |     |         |       |<br />
| job       | varchar(9)            | NO   |     |         |       |<br />
| mgr       | mediumint(8) unsigned | NO   |     | 0       |       |<br />
| hiredatea | date                  | YES  |     | NULL    |       |<br />
+-----------+-----------------------+------+-----+---------+-------+<br />
5 rows in set (0.01 sec)</pre>
</div>
<p>(2).有not null、无default</p>
<div>
<pre class="prettyprint linenums">mysql&gt; call AddColumnIfNotExists('emp', 'sal', 'DECIMAL(7,2) not null comment "<br />
薪水"', '');<br />
+---------------------------------------------------------------------------+<br />
| @stmt                                                                     |<br />
+---------------------------------------------------------------------------+<br />
|  ALTER TABLE `emp` ADD COLUMN `sal` DECIMAL(7,2) not null comment "薪水";   |<br />
+---------------------------------------------------------------------------+<br />
1 row in set (0.06 sec)

Query OK, 0 rows affected (0.09 sec)

mysql&gt; desc emp;<br />
+-----------+-----------------------+------+-----+---------+-------+<br />
| Field     | Type                  | Null | Key | Default | Extra |<br />
+-----------+-----------------------+------+-----+---------+-------+<br />
| empno     | mediumint(8) unsigned | NO   |     | 0       |       |<br />
| ename     | varchar(20)           | NO   |     |         |       |<br />
| job       | varchar(9)            | NO   |     |         |       |<br />
| mgr       | mediumint(8) unsigned | NO   |     | 0       |       |<br />
| hiredatea | date                  | YES  |     | NULL    |       |<br />
| sal       | decimal(7,2)          | NO   |     | NULL    |       |<br />
+-----------+-----------------------+------+-----+---------+-------+<br />
6 rows in set (0.01 sec)</pre>
</div>
<p>(3).无null、有default</p>
<div>
<pre class="prettyprint linenums">mysql&gt; call AddColumnIfNotExists('emp', 'comm', 'DECIMAL(7,2) default 0 comment<br />
"红利"', '');<br />
+--------------------------------------------------------------------------------------+<br />
| @stmt|<br />
+--------------------------------------------------------------------------------------+<br />
|  ALTER TABLE `emp` ADD COLUMN `comm` DECIMAL(7,2) default 0 comment "红利" NOT NULL;  |<br />
+--------------------------------------------------------------------------------------+<br />
1 row in set (0.06 sec)

Query OK, 0 rows affected (0.09 sec)

mysql&gt; desc emp;<br />
+-----------+-----------------------+------+-----+---------+-------+<br />
| Field     | Type                  | Null | Key | Default | Extra |<br />
+-----------+-----------------------+------+-----+---------+-------+<br />
| empno     | mediumint(8) unsigned | NO   |     | 0       |       |<br />
| ename     | varchar(20)           | NO   |     |         |       |<br />
| job       | varchar(9)            | NO   |     |         |       |<br />
| mgr       | mediumint(8) unsigned | NO   |     | 0       |       |<br />
| hiredatea | date                  | YES  |     | NULL    |       |<br />
| sal       | decimal(7,2)          | NO   |     | NULL    |       |<br />
| comm      | decimal(7,2)          | NO   |     | 0.00    |       |<br />
+-----------+-----------------------+------+-----+---------+-------+<br />
7 rows in set (0.01 sec)</pre>
</div>
<p>(4).有not null、有default、插入都某个字段之后</p>
<div>
<pre class="prettyprint linenums">mysql&gt; call AddColumnIfNotExists('emp', 'deptno', 'varchar(20) not null default<br />
"" comment "部门编号"', 'job');<br />
+------------------------------------------------------------------------------------------------------+<br />
| @stmt  |<br />
+------------------------------------------------------------------------------------------------------+<br />
|  ALTER TABLE `emp` ADD COLUMN `deptno` varchar(20) not null default "" comment "部门编号" after job;  |<br />
+------------------------------------------------------------------------------------------------------+<br />
1 row in set (0.06 sec)

Query OK, 0 rows affected (0.13 sec)

mysql&gt; desc emp;<br />
+-----------+-----------------------+------+-----+---------+-------+<br />
| Field     | Type                  | Null | Key | Default | Extra |<br />
+-----------+-----------------------+------+-----+---------+-------+<br />
| empno     | mediumint(8) unsigned | NO   |     | 0       |       |<br />
| ename     | varchar(20)           | NO   |     |         |       |<br />
| job       | varchar(9)            | NO   |     |         |       |<br />
| deptno    | varchar(20)           | NO   |     |         |       |<br />
| mgr       | mediumint(8) unsigned | NO   |     | 0       |       |<br />
| hiredatea | date                  | YES  |     | NULL    |       |<br />
| sal       | decimal(7,2)          | NO   |     | NULL    |       |<br />
| comm      | decimal(7,2)          | NO   |     | 0.00    |       |<br />
+-----------+-----------------------+------+-----+---------+-------+<br />
8 rows in set (0.01 sec)</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4mjpjq.html">&lbrack;archlinux&rsqb;&lbrack;hardware&rsqb; ThankPad T450自带SSD做bcache之后的使用寿命分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq14235q.html">查看表的datapages</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4wlke9.html">Java链表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv27voq.html">Windows2008防火墙封ip</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1llz69.html">JavaScript自学代码--（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z6zm59.html">测试gcc的优化选项</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljjoke9.html">&lbrack;2014 Regional&rsqb;牡丹江 H Hierarchical Notation 做题记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojjvmxq.html">2048 Puzzle游戏攻略</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zmkdj9.html">《算法导论》习题2&period;3-6 改进的InsertSort</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p54348.html">React中父组件与子组件之间的数据传递和标准化的思考</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zol1e1q.html">session与cookie的区别与联系</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyg0vk9.html">使用FileUpload实现Servlet的文件上传</a>
		</li>
						<li><a href="https://www.batexi.com/a/960jop49.html">详解设计模式在Spring中的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj4epz9.html">ubuntu下 pthread&lowbar;mutex&lowbar;init man中查不到</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2lz4oq.html">select实现简单TCP通信&lpar;ubuntu 18&period;04&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvyypk8.html">Python基础-字符串、集合类型、判断、深拷贝与浅拷贝、文件读写</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd6k0j9.html">spring整合junit报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o3dlj8.html">tomcat相关配置技巧梳理 &lpar;修改站点目录、多项目部署、限制ip访问、大文件上传超时等&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyxonjq.html">C&plus;&plus;中struct 和 class的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjzlkr9.html">Idea下载安装</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1r76dz8.html">559&period; Maximum Depth of N-ary Tree C&plus;&plus;N叉树的最大深度</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r52rldq.html">2017-5-19&amp;amp&semi;5-23&sol;系统性能指标</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25zl1vq.html">Nginx配置&mdash;&mdash;区分PC或手机访问不同域名</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1o44l9.html">C&num; 3&period;0 &sol; C&num; 3&period;5 自动属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj77k09.html">flex布局文本过长不显示省略号</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvgg138.html">C&plus;&plus; leetcode&colon;&colon;two sum</a>
			</li>
						<li><a href="https://www.batexi.com/a/960remn9.html">MSSQL2012中SQL调优（SQL TUNING）时CBO支持和常用的hints</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1o5m49.html">redis sentinel哨兵模式集群搭建教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1owr09.html">vs2015如何使用附加进程调试发布在IIS上项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/960rx6y9.html">Theano笔记</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
